automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH] Improve test coverage of current TESTS semantics.


From: Ralf Wildenhues
Subject: [PATCH] Improve test coverage of current TESTS semantics.
Date: Mon, 6 Oct 2008 22:54:05 +0200
User-agent: Mutt/1.5.18 (2008-05-17)

I noted that the coreutils check.mk script, when used for
automake/tests/, would cause no tests failures, which is great.  But
there is a bug in check.mk wrt. matching of X{FAIL,PASS} and tests in
subdirs.  (And it outputs the names of the logs instead of the tests.)

Also, I noted that @substituted@ TESTS are not tested at all.

I'm adding a couple of tests to expose all these things (both branches,
since these semantics are not new at all).

Cheers,
Ralf

    Improve test coverage of current TESTS semantics.
    
    * tests/check8.test: New test, for subdir tests and setting of
    $srcdir.
    * tests/check9.test: New test, check @substituted@ TESTS.
    * tests/Makefile.am: Update.

diff --git a/tests/Makefile.am b/tests/Makefile.am
index f3a0880..7f9ff9f 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -94,6 +94,8 @@ check4.test \
 check5.test \
 check6.test \
 check7.test \
+check8.test \
+check9.test \
 checkall.test \
 clean.test \
 clean2.test \
diff --git a/tests/check8.test b/tests/check8.test
new file mode 100755
index 0000000..242be56
--- /dev/null
+++ b/tests/check8.test
@@ -0,0 +1,94 @@
+#! /bin/sh
+# Copyright (C) 2008  Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Check subdir TESTS.
+
+. ./defs || Exit 1
+
+set -e
+
+cat >> configure.in << 'END'
+AC_PROG_CC
+AM_PROG_CC_C_O
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+AUTOMAKE_OPTIONS = subdir-objects
+TESTS = foo sub/foo $(check_PROGRAMS)
+XFAIL_TESTS = foo sub/baz
+check_PROGRAMS = bar sub/bar baz sub/baz
+END
+
+mkdir sub
+
+cat >>foo <<'END'
+#! /bin/sh
+test -f "$srcdir/Makefile.am"
+END
+cat >>sub/foo <<'END'
+#! /bin/sh
+test -f "$srcdir/Makefile.am"
+END
+chmod a+x foo sub/foo
+
+cat >>bar.c <<'END'
+int main() { return 0; }
+END
+cat >>sub/bar.c <<'END'
+int main() { return 0; }
+END
+cat >>baz.c <<'END'
+#include <stdlib.h>
+int main() { return EXIT_FAILURE; }
+END
+cat >>sub/baz.c <<'END'
+#include <stdlib.h>
+int main() { return EXIT_FAILURE; }
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+
+unset TESTS || :
+
+./configure
+AM_COLOR_TESTS=always $MAKE -e check >stdout && { cat stdout; Exit 1; }
+cat stdout
+grep 'XPASS.* foo$' stdout
+grep '^[^X]*PASS.* sub/foo$' stdout
+grep '^[^X]*PASS.* bar$' stdout
+grep '^[^X]*PASS.* sub/bar$' stdout
+grep '^[^X]*FAIL.* baz$' stdout
+grep 'XFAIL.* sub/baz$' stdout
+
+$MAKE distclean
+
+mkdir build
+cd build
+../configure
+$MAKE check >stdout && { cat stdout; Exit 1; }
+cat stdout
+# Note: we are not grepping for the space here, due to the Solaris make VPATH
+# rewriting (if we fix that, we can still write a separate test for it).
+grep 'XPASS.*foo$' stdout
+grep '^[^X]*PASS.*sub/foo$' stdout
+grep '^[^X]*PASS.*bar$' stdout
+grep '^[^X]*PASS.*sub/bar$' stdout
+grep '^[^X]*FAIL.*baz$' stdout
+grep 'XFAIL.*sub/baz$' stdout
+:
diff --git a/tests/check9.test b/tests/check9.test
new file mode 100755
index 0000000..91c37c5
--- /dev/null
+++ b/tests/check9.test
@@ -0,0 +1,80 @@
+#! /bin/sh
+# Copyright (C) 2008  Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Check @substituted@ TESTS.
+# Note that in this test, we rely on the .test extension for the
+# substituted names: this is necessary for parallel-tests.
+
+. ./defs || Exit 1
+
+set -e
+
+cat >> configure.in << 'END'
+AC_PROG_CC
+AC_SUBST([script_tests], ['subst-pass-script.test subst-xfail-script.test'])
+AC_SUBST([prog_tests], ['subst-pass-prog.test$(EXEEXT) 
subst-xfail-prog.test$(EXEEXT)'])
+AC_SUBST([xfail_tests], ['xfail-script.test subst-xfail-script.test xfail-prog 
subst-xfail-prog.test$(EXEEXT)'])
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+TESTS = pass-script.test xfail-script.test @script_tests@ $(check_PROGRAMS)
+XFAIL_TESTS = @xfail_tests@
+check_PROGRAMS = pass-prog xfail-prog @prog_tests@
+EXTRA_PROGRAMS = subst-pass-prog.test subst-xfail-prog.test
+END
+
+cat >>pass-script.test <<'END'
+#! /bin/sh
+exit 0
+END
+cat >>xfail-script.test <<'END'
+#! /bin/sh
+exit 1
+END
+chmod a+x pass-script.test xfail-script.test
+cp pass-script.test subst-pass-script.test
+cp xfail-script.test subst-xfail-script.test
+
+cat >>pass-prog.c <<'END'
+int main() { return 0; }
+END
+cat >>xfail-prog.c <<'END'
+#include <stdlib.h>
+int main() { return EXIT_FAILURE; }
+END
+# The .test extension is removed for the default source file name:
+cp pass-prog.c subst-pass-prog.c
+cp xfail-prog.c subst-xfail-prog.c
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+
+unset TESTS || :
+
+./configure
+$MAKE all
+$MAKE check
+$MAKE distclean
+
+mkdir build
+cd build
+../configure
+$MAKE all
+$MAKE check
+$MAKE distclean
+:




reply via email to

[Prev in Thread] Current Thread [Next in Thread]